/*
 *  gcube
 *  Copyright (c) 2004 monk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *  utility functions
 *      
 *         
 */

#include "general.h"



unsigned int file_exists (char *filename)
{
	FILE *f;


	f = fopen (filename, "r");
	if (!f)
		return FALSE;
	else
	{
		fclose (f);
		return TRUE;
	}
}


FILE *flog = NULL;

void log_open (char *filename)
{
	if (!flog)
		flog = fopen (filename, "w+");
}


void log_printf (char *fmt, ...)
{
	va_list ap;


	va_start (ap, fmt);
	vfprintf (flog, fmt, ap);
	va_end (ap);
}


void log_close (void)
{
	printf (".log: close\n");
	if (flog)
	{
		fclose (flog);
		flog = NULL;
	}
}


char *get_filename (char *name, const char *path)
{
	char *c;


	c = strrchr (path, '/');
	if (c)
		strcpy (name, c + 1);
	else
	{
		c = strrchr (path, '\\');
		if (c)
			strcpy (name, c + 1);
		else
			// path is filename
			strcpy (name, path);
	}

	return name;
}


char *get_extension (char *ext, const char *filename)
{
	char str[256], *c;


	get_filename (str, filename);

	c = strrchr (str, '.');
	if (c)
		strcpy (ext, c + 1);
	else
		*ext = '\0';
	
	return ext;
}


char *kill_extension (char *filename)
{
	char *c;


	c = strrchr (filename, '.');
	if (c)
		*c = '\0';
	
	return filename;
}


char *get_home_dir (void)
{
	return getenv ("HOME");
}
