#ifndef __GENERAL_H
#define __GENERAL_H 1

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "types.h"

#ifdef ASM_X86
# include "asm_x86.h"
#endif

#ifndef FALSE
# define FALSE 0
#endif

#ifndef TRUE
# define TRUE !FALSE
#endif


unsigned int file_exists (char *filename);

void log_open (char *filename);
void log_printf (char *fmt, ...);
void log_close (void);

char *get_filename (char *name, const char *path);
char *get_extension (char *ext, const char *filename);
char *kill_extension (char *filename);

char *get_home_dir (void);


#endif // __GENERAL_H
