
// input test

#include <mygcn.h>


u32 *fb = (u32 *) 0xc0500000;


void show_pad_status (int npad, int x, int y)
{
	PAD pad;
	char *status[] =
	{
		"Up", "Down", "Left", "Right", "L", "R", "A", "B", "X", "Y", "Z", "Start",
		"AX", "AY", "ACX", "ACY", "AL", "AR",
	};
	s8 *btest[] =
	{
		&pad.Digital.Up, &pad.Digital.Down, &pad.Digital.Left, &pad.Digital.Right,
		&pad.Digital.L, &pad.Digital.R, &pad.Digital.A, &pad.Digital.B,
		&pad.Digital.X, &pad.Digital.Y, &pad.Digital.Z, &pad.Digital.Start,
		&pad.Analog.X, &pad.Analog.Y, &pad.AnalogC.X, &pad.AnalogC.Y,
		&pad.Trigger.L, &pad.Trigger.R,
	};
	char buff[128];
	int i;


	PAD_ReadState (&pad, PAD_CHANNEL_0 + npad);

	// show status of the buttons
	for (i = 0; i < 12; i++)
		if (*btest[i])
			DEBUG_Print (x, y += 20, status[i]);

	// show status of analogs
	for (i = 12; i < 18; i++)
	{
		if (*btest[i])
		{
			sprintf (buff, "%s %4d", status[i], *btest[i]);

			DEBUG_Print (x, y += 20, buff);
		}
	}
}


int main (void)
{
	VIDEO_Init (VIDEO_640X480_NTSC_YUV16);
	VIDEO_SetFrameBuffer (VIDEO_FRAMEBUFFER_BOTH, (u32) fb);
	DEBUG_InitText (fb, COLOR_WHITE);

	while (1)
	{
		memset (fb, 0x80, 640*480*4);

		DEBUG_Print (10, 20, "INPUT TEST");

		DEBUG_Print (10, 60, "gamepad1");
		show_pad_status (0, 10, 100);

		DEBUG_Print (160, 60, "gamepad2");
		show_pad_status (1, 160, 100);

		DEBUG_Print (310, 60, "gamepad3");
		show_pad_status (2, 310, 100);

		DEBUG_Print (460, 60, "gamepad4");
		show_pad_status (3, 460, 100);

		VIDEO_WaitVSync ();
	}

	return FALSE;
}
